"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LC1Switch = void 0;
const broadlink = __importStar(require("node-broadlink"));
class LC1Switch {
    constructor(platform, accessory) {
        var _a, _b, _c;
        this.platform = platform;
        this.accessory = accessory;
        this.state = {
            pwr1: Boolean(this.accessory.context.device.status.pwr1),
            pwr2: Boolean(this.accessory.context.device.status.pwr2),
            pwr3: Boolean(this.accessory.context.device.status.pwr3),
        };
        this.setOn = (key) => async (value) => {
            const { uniqueId } = this.accessory.context.device;
            const hub = await this.getHubDevice();
            this.state = await hub.setState({
                did: uniqueId,
                ...this.state,
                [key]: value,
            });
            this.platform.log.debug('Set Characteristic On ->', value);
        };
        this.getOn = (key) => async () => {
            const { uniqueId } = this.accessory.context.device;
            const hub = await this.getHubDevice();
            const state = await hub.getState(uniqueId);
            this.state[key] = state[key];
            this.platform.log.debug('Get Characteristic On ->', state[key]);
            return state[key];
        };
        this.getHubDevice = async () => {
            const { host } = this.accessory.context.device;
            const devices = await broadlink.discover();
            const hub = devices.find(d => d.host.address === host.address);
            return (await hub.auth());
        };
        this.accessory
            .getService(this.platform.Service.AccessoryInformation)
            .setCharacteristic(this.platform.Characteristic.Manufacturer, 'Broadlink')
            .setCharacteristic(this.platform.Characteristic.Model, 'LC1')
            .setCharacteristic(this.platform.Characteristic.SerialNumber, this.accessory.context.device.uniqueId);
        this.services = {
            one: (_a = this.accessory.getService('Switch One')) !== null && _a !== void 0 ? _a : this.accessory.addService(this.platform.Service.Switch, 'Switch One', this.platform.api.hap.uuid.generate(`${this.accessory.context.device.uniqueId}-0`)),
        };
        this.services.one.setCharacteristic(this.platform.Characteristic.Name, 'Switch One');
        this.services.one
            .getCharacteristic(this.platform.Characteristic.On)
            .onSet(this.setOn('pwr1'))
            .onGet(this.getOn('pwr1'));
        if (this.accessory.context.device.gangs > 1) {
            this.services.two =
                (_b = this.accessory.getService('Switch Two')) !== null && _b !== void 0 ? _b : this.accessory.addService(this.platform.Service.Switch, 'Switch Two', this.platform.api.hap.uuid.generate(`${this.accessory.context.device.uniqueId}-1`));
            this.services.two.setCharacteristic(this.platform.Characteristic.Name, 'Switch Two');
            this.services.two
                .getCharacteristic(this.platform.Characteristic.On)
                .onSet(this.setOn('pwr2'))
                .onGet(this.getOn('pwr2'));
        }
        if (this.accessory.context.device.gangs > 2) {
            this.services.three =
                (_c = this.accessory.getService('Switch Three')) !== null && _c !== void 0 ? _c : this.accessory.addService(this.platform.Service.Switch, 'Switch Three', this.platform.api.hap.uuid.generate(`${this.accessory.context.device.uniqueId}-2`));
            this.services.three.setCharacteristic(this.platform.Characteristic.Name, 'Switch Three');
            this.services.three
                .getCharacteristic(this.platform.Characteristic.On)
                .onSet(this.setOn('pwr3'))
                .onGet(this.getOn('pwr3'));
        }
    }
}
exports.LC1Switch = LC1Switch;
//# sourceMappingURL=LC1Switch.js.map